#! /bin/sh
#Version:       1.9.5 2008-05-23

command="$1"
shift

if [ "$command" = "add" ]
then

for i in "$@"
do
	  i="$i\""
	  i=${i/\=/=\"}
	  eval export $i
done

#ignore for now
unset DisableUserLogin

export options=""
if [ -n "$UserID" ]
then
  if test $UserID -lt 500
  then
    echo 'returncode="33" Message="UserID should be larger than 499."'
    exit
  fi

  options="$options -u $UserID"
fi

if [ -z "$PERL_BIN" ]
then
  export PERL_BIN=/usr/bin
fi

export Password=`$PERL_BIN/perl -e '$pass=<> ; $salt=join "",( ".", "/",  0..9, "a".."z", "A".."Z")[rand 64, rand 64]; $pass =~ s/^\s*(.*?)\s*$/$1/ ; if (length($pass) <= 4) {print "short"} else {print crypt($pass,$salt) unless $pass eq "";}'`

#export Password=`$PERL_BIN/perl -e '$pass=<> ; $pass =~ s/^\s*(.*?)\s*$/$1/ ;print crypt($pass,"salt") unless $pass eq "";'`

if [ "$Password" = "short" ]
then
	echo 'returncode="91" Message="Password needs to be at least 5 characters long."'
	exit
fi

if [ -n "$Password" ]
then
	if [ -n "$DisableUserLogin" ]
	then
	   case "$DisableUserLogin" in
	   y*|Y*|t*|T*)
		Password="!$Password"
		;;
	   esac
	fi
	options="$options -p '$Password'"
else
	if [ -n "$DisableUserLogin" ]
	then
	   case "$DisableUserLogin" in
	   y*|Y*|t*|T*)
		Password="!"
	        options="$options -p '$Password'"
		;;
	   esac
	fi
fi

options="$options -c '$FullName,$AdditionalUserInformation'"


if [ -n "$HomeDirectory" ]
then
  options="$options -d '$HomeDirectory'"
fi

if [ -n "$EmptyHome" ]
then
   case "$EmptyHome" in
   n*|N*|f*|F*)
	  options="$options -m "
	  ;;
   y*|Y*|t*|T*)
          if [ -e "/etc/redhat-release" ]
          then
                options="$options -M "
          fi
   esac
fi

if [ -n "$LoginShell" ]
then
  options="$options -s '$LoginShell'"
fi

if [ -n "$DefaultGroup" ]
then
  options="$options -g '$DefaultGroup'"
fi

if [ -n "$GroupMemberships" ]
then
  options="$options -G '$GroupMemberships'"
fi




# last option
if [ -n "$UserName" ]
then
  options="$options $UserName"
  exists=`grep "^$UserName:" /etc/passwd`
  if [ -n "$exists" ] 
  then
    echo 'returncode="11" Message="UserName already exists."'
    exit
  fi
else
   echo 'returncode="1" Message="UserName not given."'
   exit
fi 

msg=`eval /usr/sbin/useradd $options 2>&1`
rc=$?
if [ "$rc" -ne "0" ]
then
		exists=`grep "^$UserName:" /etc/passwd`
	        if [ -n "$exists" ] 
		then
		echo "returncode=\"82\" Message=\"User added with warning:  $msg \""
		else
			if [ "$rc" -eq "4" ]
			then
			  echo "returncode=\"8\" Message=\"Add user failed :  userid exists. Please verify that the userid doesn't exist locally or in NIS\""
			else
			  echo "returncode=\"8\" Message=\"Add user failed :  $msg\""
			fi
		fi
	exit
else
	echo 'returncode="0" Message="User added."'
	exit
fi

fi

if [ "$command" = "update" ]
then

for i in "$@"
do
  i="$i\""
  i=${i/\=/=\"}
  eval export $i
done

export options=""
if [ -n "$UserID" ]
then
  if test $UserID -lt 500
  then
    echo 'returncode="33" Message="UserID should be larger than 499."'
    exit
  fi

  old_id=`grep ^$UserName: /etc/passwd | cut -d: -f 3`
  if [ "$old_id" != "$UserID" ]
  then
    options="$options -u $UserID"
  fi
fi

if [ -z "$PERL_BIN" ]
then
  export PERL_BIN=/usr/bin
fi

export Password=`$PERL_BIN/perl -e '$pass=<> ; $salt=join "",( ".", "/",  0..9, "a".."z", "A".."Z")[rand 64, rand 64]; $pass =~ s/^\s*(.*?)\s*$/$1/ ; if (length($pass) == 0) {print ""} elsif (length($pass) <= 4) {print "short"} else {print crypt($pass,$salt) unless $pass eq "";}'`
#export Password=`$PERL_BIN/perl -e '$pass=<> ; $pass =~ s/^\s*(.*?)\s*$/$1/ ;print crypt($pass,"salt") unless $pass eq "";'`

if [ "$Password" = "short" ]
then
	echo 'returncode="91" Message="Password needs to be at least 5 characters long."'
	exit
fi

if [ -n "$Password" ]
then
	options="$options -p '$Password'"
fi

if [ -n "DisableUserLogin" ]
then

           case "$DisableUserLogin" in
           y*|Y*|t*|T*)
	        options="$options -L"
                ;;
           n*|N*|f*|F*)
	        options="$options -U"
                ;;
           esac
fi


options="$options -c '$FullName,$AdditionalUserInformation'"

if [ -n "$HomeDirectory" ]
then
  options="$options -d '$HomeDirectory'"
fi


if [ -n "$LoginShell" ]
then
  options="$options -s '$LoginShell'"
fi

if [ -n "$DefaultGroup" ]
then
  options="$options -g '$DefaultGroup'"
fi

if [ -n "$GroupMemberships" ]
then
  options="$options -G '$GroupMemberships'"
fi




# last option
if [ -n "$UserName" ]
then
  options="$options $UserName"
else
   echo 'returncode="1" Message="UserName not given."'
   exit
fi 

msg=`eval /usr/sbin/usermod $options 2>&1`
rc=$?
if [ "$rc" -ne "0" ]
then
	echo "returncode=\"9\" Message=\"Update user failed : $msg\""
	exit
else
	echo 'returncode="0" Message="User updated."'
	exit
fi

fi

if [ "$command" = "delete" ]
then

for i in "$@"
do
  i="$i\""
  i=${i/\=/=\"}
  eval export $i
done

if [ -n "$UserName" ]
then
  account="$UserName"
else
  if [ -n "$UserID" ]
  then
     account=`grep "^[^:]*:[^:]*:$UserID:" /etc/passwd | cut -d: -f1`
  fi
fi


if [ -n "$account" ]
then
     msg=`/usr/sbin/userdel "$account" 2>&1`
     rc=$?
     if [ "$rc" -ne "0" ]
     then
	echo "returncode=\"3\" Message=\"Delete failed : $msg\""
        exit
     else
	echo 'returncode="0" Message="User deleted."'
        exit
     fi
else
     echo 'returncode="2" Message="UserName not found."'
     exit
fi

fi
