#! /bin/bash
# Version:       1.9.5 2008-05-23
# Call as follows : RunYast.sh full_path_to_yast arg1 arg2 ...
# e.g. RunYast.sh /sbin/yast2 EM-host help 
#Changelog: 2008-12-3 Added filter for sudo warning

#fix for remote agent where TERM is not set
export TERM=dumb 
export LOCALE=C

unset PERL5LIB
user=`id -un` # print the userid as a name (not a number)
eval export HOME=~$user
yast=$1; shift
parse="cat"
parseopt="-"


killsudo="no"
declare -i i
i=0

if [ "$yast" = "sudo" ]
then
  sudo="sudo"; sudopt="-S -p Password:" ; 
  shift
  yast=$1; shift
  parse="awk"
  parseopt='BEGIN { copy=0; } /^Password:/ { copy=1; } {if (copy==1) { print } }'
fi

a=("$@")
while [ $i -lt ${#a[*]} ]
do
  if [ "${a[$i]}" = "killsudo=yes" ]
  then
	killsudo="yes"
	break
  fi
  i=$i+1
done
unset  a[$i]


script=`basename $1 .ycp`
if [ "$script" = "EM-users" ]
then
  if [ "$!#" != "help" -a "$2" != "list" -a "$2" != "listLoginShell" -a "$2" ]
  then
	script="$1"; shift
	script=${script/%.ycp/.sh}
	$sudo $sudopt /bin/bash $script "$@" 2>&1| $parse "$parseopt"
  else
	#a=("$@")
	b=("${a[@]/%RunLevel=/RunLevel=none}")
	c=("${b[@]/%MountOptions=/MountOptions=defaults}")
	d=("${c[@]/%HostAlias=/HostAlias=none}")
	e=("${d[@]/%=/=<none>}")
	set -- "${e[@]}"

	$sudo $sudopt $yast "$@" 2>&1 | $parse "$parseopt"
  fi

else
	#a=("$@")
	b=("${a[@]/%RunLevel=/RunLevel=none}")
	c=("${b[@]/%MountOptions=/MountOptions=defaults}")
	d=("${c[@]/%HostAlias=/HostAlias=none}")
	e=("${d[@]/%=/=<none>}")
	set -- "${e[@]}"

	$sudo $sudopt $yast "$@" 2>&1 | $parse "$parseopt"
fi

if [ "$killsudo" = "yes" ]
then
   if [ -n "$SUDO_USER" ]
   then
	su $SUDO_USER -c "sudo -k"
   else
        sudo -k 
   fi
fi
